#ifndef PARSE__H
#define PARSE__H

#include <stdio.h>

enum { SUB_TREE = 0, INT, STRING, SYMBOL };

typedef struct node {
  struct node ** childs;
  int child_count;
  int type;
  unsigned int int_data;
  char * str_data;
  char * symbol_data;
} node;

typedef struct list {
  node * n;
  struct list * next;
} list;

void encountered_eof(char *);
void * xmalloc(size_t);
void * xrealloc(void *, size_t);
void expand_childs(node *, size_t);
node * new_node(int);
void destroy_node(node *);
char * parse_str(FILE *);
char * parse_str2(FILE *);
int isws(int);
void skip_ws(FILE *, int);
node * do_parse(FILE *);
node * parse_subtree(FILE *);
node * parse_num(FILE *);
node * parse_symbol(FILE *);
node * parse_string(FILE *);
list * new_list_element(void);
void add_to_list(list **, list **, node *);
void print_parse_tree(list *);
void print_subtree(node *);
char * type_lookup(int);


#endif
